From:  Yan Lei <yan_lei@dahuatech.com>
Date: Fri, 25 Mar 2022 15:50:00 +0800
Subject: [PATCH] fix Memory is deallocated more than once vdev->fault_pages

dahua inclusion
category: bugfix
bugzilla: https://gitee.com/openeuler/kernel/issues/I4ZKXP
CVE: NA

----------------------------------------------------------
Memory is deallocated more than once (CWE-415)
"*vdev->region[i].ops->release" frees "vdev->fault_pages". 
Calling "*vdev->region[i].ops->release" frees pointer 
"vdev->fault_pages" which has already been freed. 
(The function pointer resolves to "vfio_pci_dma_fault_release".)

Signed-off-by: Yan Lei <yan_lei@dahuatech.com>

---
 drivers/vfio/pci/vfio_pci.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

diff --git a/drivers/vfio/pci/vfio_pci.c b/drivers/vfio/pci/vfio_pci.c
index ee73b1b2e..ed10d3aa9
--- a/drivers/vfio/pci/vfio_pci.c
+++ b/drivers/vfio/pci/vfio_pci.c
@@ -368,7 +368,10 @@ int vfio_pci_set_power_state(struct vfio_pci_device *vdev, pci_power_t state)
 static void vfio_pci_dma_fault_release(struct vfio_pci_device *vdev,
 				       struct vfio_pci_region *region)
 {
-	kfree(vdev->fault_pages);
+	if(vdev->fault_pages) {
+		kfree(vdev->fault_pages);
+		vdev->fault_pages = NULL;
+	}
 }
 
 static void
-- 
2.30.0

